#!/usr/bin/python
#-*- coding: utf-8 -*-
#auth: robert_du

import requests
import json
import sys
reload(sys)
sys.setdefaultencoding('utf-8')

def user_login(url,headers):
    data = {
             "jsonrpc": '2.0',
             "method": "user.login",
             "params": {
                         "user": "Admin",
                         "password": "zabbix"
                       },
             "id": 1,
             "auth": None,
           }
    json_data = json.dumps(data)
    res = requests.post(url,data=json_data, headers = headers)
    res_data_dic = json.loads(res.text)
    is_success = res_data_dic.get('result')
    if is_success:
        return is_success

class zabbix_api:
    def __init__(self):
        self.url = "http://10.26.29.147/zabbix/api_jsonrpc.php"
        self.headers = {'Content-Type': 'application/json-rpc'}
        self.Session = user_login(self.url,self.headers)
        self.seccess_id=[]
        self.failure_id=[]
        

    def host_get(self,hostName=''):
        print "get host id"
        data = {
                 "jsonrpc": '2.0',
                 "method": "host.get",
                 "params": {
                             "output": "extend",
                             "search": {'name':hostName},
                           },
                 "auth": self.Session,
                 "id": 1,
               }
        json_data = json.dumps(data)
        res = requests.post(self.url,data=json_data, headers = self.headers)
        res_data_dic = json.loads(res.text)

        if not len(res_data_dic.get('result')):
            print "\033[041m %s \033[0m is not exist" % hostName
            return False
        self.hostids=[]
        print "######host查询结果######"
        for host in res_data_dic.get('result'):
            print "主机名：%s ,主机ID：%s" % (host['name'],host['hostid'])
            ## return host['hostid']
            self.hostids.append(host['hostid'])
        return self.hostids

    def item_get(self,hostName,searchKey=None):
        hostids = self.host_get(hostName)
        if len(hostids):
           print "get itemid"
           self.itemids=[]
           for hostid in hostids:
               data = {
                        "jsonrpc": '2.0',
                        "method": "item.get",
                        "params": {
                                   "output": "extend",
                                   "hostids": hostid,
                                   "search": {"key_": searchKey},
                                  },
                        "auth": self.Session,
                        "id": 1,
                      }
               json_data = json.dumps(data)
               res = requests.post(self.url,data=json_data, headers = self.headers)
               res_data_dic = json.loads(res.text)
               #print res_data_dic.get('result')
               for item in res_data_dic.get('result'):
                   print "%s -------> %s" % (item['hostid'],item['itemid'])
                   self.itemids.append(item['itemid'])
           return self.itemids

    def host_disable(self,hostName):
        hostids = self.host_get(hostName)
        print "disable host"
        if len(hostids):
           for hostid in hostids:
               data = {
                        "jsonrpc": '2.0',
                        "method": "host.update",
                        "params": {
                                   "hostid": hostid,
                                   "status": 1
                                  },
                        "auth": self.Session,
                        "id": 1,
                      }
               json_data = json.dumps(data)
               res = requests.post(self.url,data=json_data, headers = self.headers)
               res_data_dic = json.loads(res.text)
               #print res_data_dic.get('result')
               if res.status_code == 200:
                    self.seccess_id.append(itemid)
               else:
                    self.failure_id.append(itemid)
           return {'Seccess':self.seccess_id, 'Failure': self.failure_id}

    def host_enable(self,hostName):
        hostids = self.host_get(hostName)
        print "enable host"
        if len(hostids):
           for hostid in hostids:
               data = {
                        "jsonrpc": '2.0',
                        "method": "host.update",
                        "params": {
                                   "hostid": hostid,
                                   "status": 0
                                  },
                        "auth": self.Session,
                        "id": 11,
                      }
               json_data = json.dumps(data)
               res = requests.post(self.url,data=json_data, headers = self.headers)
               res_data_dic = json.loads(res.text)
               print res_data_dic
               if res.status_code == 200:
                    self.seccess_id.append(itemid)
               else:
                    self.failure_id.append(itemid)
           return {'Seccess':self.seccess_id, 'Failure': self.failure_id}

    def item_disable(self,hostName,searchKey):
        itemids = self.item_get(hostName,searchKey)
        print "disable item"
        if len(itemids):
           for itemid in itemids:
               data = {
                        "jsonrpc": '2.0',
                        "method": "item.update",
                        "params": {
                                   "itemid": itemid,
                                   "status": 1
                                  },
                        "auth": self.Session,
                        "id": 1,
                      }
               json_data = json.dumps(data)
               res = requests.post(self.url,data=json_data, headers = self.headers)
               
               #res_data_dic = json.loads(res.text)
               if res.status_code == 200:
                    self.seccess_id.append(itemid)
                    print "%s 禁用成功" % itemid
               else:
                    self.failure_id.append(itemid)
                    print "%s 禁用失败" % itemid
           return {'Seccess':self.seccess_id, 'Failure': self.failure_id}

    def item_enable(self,hostName,searchKey):
        itemids = self.item_get(hostName,searchKey)
        print "enable item"
        if len(itemids):
           for itemid in itemids:
               data = {
                        "jsonrpc": '2.0',
                        "method": "item.update",
                        "params": {
                                   "itemid": itemid,
                                   "status": 0
                                  },
                        "auth": self.Session,
                        "id": 1,
                      }
               json_data = json.dumps(data)
               res = requests.post(self.url,data=json_data, headers = self.headers)
               #res_data_dic = json.loads(res.text)
               if res.status_code == 200:
                    self.seccess_id.append(itemid)
                    print "%s 启用成功" % itemid
               else:
                    self.failure_id.append(itemid)
                    print "%s 启用失败" % itemid
           return {'Seccess':self.seccess_id, 'Failure': self.failure_id}

if __name__ == "__main__":
   zabbix = zabbix_api()
   #zabbix.host_get("qd01-esbook-webview004")
   #zabbix.host_disable('webview004')
   #zabbix.host_enable('webview00')
   #zabbix.item_get("qd01-esbook-webview004")
   #zabbix.item_disable("qd01-esbook-webview0",'8080')
   zabbix.item_enable("qd01-esbook-webview0",'8080')
